'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

#INCLUDE "Windows.bi"
#INCLUDE "Win/CommCtrl.bi"
#INCLUDE "Win/RichEdit.bi"

Type TMessage
    hWnd      As HWND
    Msg       As UINT
    wParam    As WPARAM
    lParam    As LPARAM
    wParamLo  As WORD
    wParamHi  As WORD
    lParamLo  As WORD
    lParamHi  As WORD
    lResultLo As WORD
    lResultHi As WORD
End Type

Type TClass
     ClassName  As String
     ClassAlias As String    
     ExStyle    As Long
     Style      As Long
     Width     As Integer
     Height     As Integer
End Type

Type TEvent
    Message As UINT
    Event   As Any Ptr
End Type

''''
Const ToolBarStyle     = WS_CHILD OR TBSTYLE_TRANSPARENT OR TBSTYLE_FLAT OR CCS_NOPARENTALIGN OR CCS_NODIVIDER
Const ButtonStyle      = WS_CHILD OR BS_DEFPUSHBUTTON
Const CheckBoxStyle    = WS_CHILD OR BS_AUTOCHECKBOX
Const RadioButtonStyle = WS_CHILD OR BS_AUTORADIOBUTTON
Const GroupBoxStyle    = WS_CHILD OR BS_GROUPBOX
'... 
'...
'AND SO ON...

#INCLUDE "TFont.bas"
#INCLUDE "Menus.bas"
#INCLUDE "TControl.bas"
#INCLUDE "TApplication.bas"
#INCLUDE "TToolButtons.bas"
#INCLUDE "TTabItems.bas"

Dim Shared As TApplication Application
Dim Shared As TControl Main
Dim Shared As TControl DesignForm
Dim Shared As TControl ComboBox
Dim Shared As TControl Button,Radio,Radio1,Radio2,Radio3
Dim Shared As TControl ToolBar
Dim Shared As TControl TabControl

Namespace EventHandlers
    Dim DoEvent     As Sub(BYREF Sender As TControl)
    Dim DoPaint     As Sub(BYREF Sender As TControl, Dc As HDC,R As RECT)
    Dim DoClick     As Sub(BYREF Sender As TControl)
    Dim DoDblClick  As Sub(BYREF Sender As TControl)
    Dim DoChange    As Sub(BYREF Sender As TControl)
    Dim DoResize    As Sub(BYREF Sender As TControl)
    Dim DoCommand   As Sub(BYREF Sender As TControl,CommandID As Integer,Code As Integer,hWindow As LPARAM)
    Dim DoMove      As Sub(BYREF Sender As TControl)
    Dim DoClose     As Sub(BYREF Sender As TControl,BYREF Action As Integer)
    Dim DoMouseDown As Sub(BYREF Sender As TControl,Button As Integer,X As Integer,Y As Integer,Shift As Integer)
    Dim DoMouseMove As Sub(BYREF Sender As TControl,X As Integer,Y As Integer,Shift As Integer)
    Dim DoMouseUp   As Sub(BYREF Sender As TControl,Button As Integer,X As Integer,Y As Integer,Shift As Integer)
    
    Dim DoMenuItemClick As Sub(BYREF Sender As TMenuItem)
    
    Sub TraverseNode(BYREF Item As TMenuItem,ID As Integer)
        Dim As Integer i
        For i = 0 To Item.ItemCount -1
            If ID = Item.Items[i].CommandID Then
               If Item.Items[i].OnClick <> NULL Then 
                   DoMenuItemClick = Item.Items[i].OnClick
                   DoMenuItemClick(Item.Items[i])
                   Exit Sub
               End If
            End If 
            TraverseNode(Item.Items[i],ID)
        Next i
    End Sub
    
    Function WndProc(hWindow As HWND,Msg As UINT,wParam As WPARAM,lParam As LPARAM) As LRESULT
        Dim As Integer Action = 1,i,k,j
        Dim As TControl Ptr Control
        Control = Cast(TControl Ptr,GetWindowLong(hWindow,GWL_USERDATA))
        Select Case Msg
        Case WM_CREATE
        Case WM_PAINT
            Dim As PAINTSTRUCT Ps
            Dim As HDC Dc
            Dim As Integer x,y
            Dc = BeginPaint(hWindow,@Ps)
            For i = 0 To Control->EventCount -1
                 If Control->Events[i].Message = WM_PAINT Then
                      DoPaint = Control->Events[i].Event
                      DoPaint(*Control,Dc,Ps.rcpaint)
                 End If
            Next i
            EndPaint hWindow,@Ps
            Return 0
        Case WM_LBUTTONDOWN
            For i = 0 To Control->EventCount -1
                 If Control->Events[i].Message = WM_LBUTTONDOWN Then
                    DoMouseDown = Control->Events[i].Event
                    DoMouseDown(*Control,0,LoWord(lParam),HiWord(lParam),wParam And &HFFFF)
                 End If
            Next i
        Case WM_MOUSEMOVE
            For i = 0 To Control->EventCount -1
                 If Control->Events[i].Message = WM_MOUSEMOVE Then
                    DoMouseMove = Control->Events[i].Event
                    DoMouseMove(*Control,LoWord(lParam),HiWord(lParam),wParam And &HFFFF)
                 End If
            Next i
        Case WM_LBUTTONUP
            For i = 0 To Control->EventCount -1
                 If Control->Events[i].Message = WM_LBUTTONUP Then
                    DoMouseUp = Control->Events[i].Event
                    DoMouseUp(*Control,0,LoWord(lParam),HiWord(lParam),wParam And &HFFFF)
                 End If
            Next i
        Case WM_CLOSE
            If Control Then
               If Control->Events[i].Message = WM_CLOSE Then
                  DoClose = Control->Events[i].Event
                  DoClose(*Control,Action)
               End If
               Select Case Action
               Case 0 : Exit Function
               Case 1 : If ((GetWindowLong(hWindow,GWL_EXSTYLE) AND WS_EX_APPWINDOW) = WS_EX_APPWINDOW) Then
                            PostQuitMessage(0)
                         Else
                            ShowWindow hWindow,SW_HIDE
                            Exit Function
                         End If
               Case 2 : ShowWindow hWindow,SW_MINIMIZE
                         Exit Function
               End Select
            End If
        Case WM_SIZE
            If Control Then
               If Control->Events[i].Message = WM_SIZE Then
                  DoResize = Control->Events[i].Event
                  DoResize(*Control)
               End If
            End If
        Case WM_MOVE
            If Control Then
               If Control->Events[i].Message = WM_MOVE Then
                  DoMove = Control->Events[i].Event
                  DoMove(*Control)
               End If
            End If
        Case WM_WINDOWPOSCHANGING
            If Control Then
               If Control->ConstraintLeft <> 0   Then Cast(WINDOWPOS Ptr,lParam)->x  = Control->ConstraintLeft
               If Control->ConstraintTop <> 0    Then Cast(WINDOWPOS Ptr,lParam)->y  = Control->ConstraintTop
               If Control->ConstraintWidth <> 0  Then Cast(WINDOWPOS Ptr,lParam)->cx = Control->ConstraintWidth
               If Control->ConstraintHeight <> 0 Then Cast(WINDOWPOS Ptr,lParam)->cy = Control->ConstraintHeight
            End If
        Case WM_COMMAND
            Dim As Integer ID = LoWord(wParam)
            If Control Then
               For i = 0 To Control->MainMenu.ItemCount -1
                   TraverseNode(Control->MainMenu.Items[i],ID)
               Next i
               For i = 0 To Control->PopupMenu.ItemCount -1
                   TraverseNode(Control->PopupMenu.Items[i],ID)
               Next i
               For i = 0 To Control->EventCount -1
                   If Control->Events[i].Message = WM_COMMAND Then
                      DoCommand = Control->Events[i].Event
                      DoCommand(*Control,LoWord(wParam),HiWord(wParam),lParam)
                      Exit For
                   End If 
               Next i
            End If
            Control = Cast(TControl Ptr,GetWindowLong(Cast(HWND,lParam),GWL_USERDATA)) 
            If Control <> NULL Then
               For i = 0 To Control->MainMenu.ItemCount -1
                   TraverseNode(Control->MainMenu.Items[i],ID)
               Next i
               For i = 0 To Control->PopupMenu.ItemCount -1
                   TraverseNode(Control->PopupMenu.Items[i],ID)
               Next i
               For i = 0 To Control->EventCount -1
                   If Control->Events[i].Message = HiWord(wParam) Then
                      DoEvent = Control->Events[i].Event
                      DoEvent(*Control)
                      Exit For
                   End If 
               Next i
            End If
        Case WM_NOTIFY
            Dim As TBNOTIFY PTR Tbn
            Dim As TBBUTTON Tb
            Dim As RECT R
            Tbn = Cast(TBNOTIFY PTR,lParam) 
            Select Case Tbn->hdr.Code
                   Case TBN_DROPDOWN 
                        If Tbn->iItem <> -1 Then
                           SendMessage(Tbn->hdr.hwndFrom, TB_GETRECT, Tbn->iItem, CInt(@R))
                           MapWindowPoints(Tbn->hdr.hwndFrom, 0, CPtr(POINT Ptr,@R), 2)
                           SendMessage(Tbn->hdr.hwndFrom,TB_GETBUTTON,SendMessage(Tbn->hdr.hwndFrom,TB_COMMANDTOINDEX,Tbn->iItem,0),CInt(@Tb))
                           TrackPopupMenu(Cast(TButtonData Ptr,Tb.dwData)->DropDown->Handle, 0, R.Left, R.Bottom, 0, Tbn->hdr.hwndFrom, NULL)
                        End If
            End Select
            Dim As NMHDR Ptr NM
            NM = Cast(NMHDR Ptr,lParam)
            Control = Cast(TControl Ptr,GetWindowLong(Cast(HWND,NM->hwndFrom),GWL_USERDATA)) 
            If Control Then 
               For i = 0 To Control->EventCount -1
                   If Control->Events[i].Message = NM->Code Then
                      DoEvent = Control->Events[i].Event
                      DoEvent(*Control)
                      Exit For
                   End If 
               Next i 
            End If
        End Select
        Return DefWindowProc(hWindow,Msg,wParam,lParam)
    End Function
End Namespace

''''''''''''''''''''''''''''''''''''''''''
Declare Sub Click(Sender As TControl)
Declare Sub Change(Sender As TControl)
Declare Sub ItemClick(Sender As TMenuItem)
Declare Sub wPaint(Sender As TControl,DC As HDC,R As RECT)

Main.Register("TFreeBasicMain",@EventHandlers.WndProc)
Main.Text    = "FreeBasic Main"
Main.ExStyle = WS_EX_APPWINDOW OR WS_EX_CONTROLPARENT
Main.Style   = WS_OVERLAPPEDWINDOW
Main.Width   = 450
Main.Height  = 113
Main.SetEvent(WM_LBUTTONDOWN,@Click)
Main.ConstraintHeight = 114
Main.Create
Main.Visible = 1

Dim As TMenuItem It,SIt
    
It.Caption = "File"
Main.MainMenu.AddItem It
It.CommandID = -1

It.Caption   = "New"
Main.MainMenu.Items[0].AddItem It

Sit.Caption   = "Project"
SIt.CommandID = 101
Sit.OnClick   = @ItemClick
Sit.checked = 1
Main.MainMenu.Items[0].Items[0].AddSubItem Sit

DesignForm.Register("TDesignForm",@EventHandlers.WndProc)
DesignForm.Text    = "DesignForm"
DesignForm.ExStyle = WS_EX_CONTROLPARENT
DesignForm.Style   = WS_OVERLAPPEDWINDOW
DesignForm.Width   = 350
DesignForm.Height  = 300
DesignForm.SetEvent(WM_PAINT,@WPaint)
DesignForm.Create
DesignForm.Visible = 1

ComboBox.ClassName = "ComboBox"
ComboBox.Style   = WS_CHILD OR WS_VSCROLL OR CBS_DROPDOWNLIST OR CBS_HASSTRINGS OR CBS_AUTOHSCROLL OR CBS_NOINTEGRALHEIGHT
ComboBox.Width   = 121
ComboBox.Height  = 42
ComboBox.Parent = Main
ComboBox.SetEvent(CBN_SELCHANGE,@Change)
ComboBox.Visible = 1
ComboBox.Perform(CB_ADDSTRING,0,CInt(StrPtr("item 0")))
ComboBox.Perform(CB_ADDSTRING,0,CInt(StrPtr("item 1")))
ComboBox.Perform(CB_ADDSTRING,0,CInt(StrPtr("item 2")))
MoveWindow ComboBox.Handle,0,0,121,21*ComboBox.Perform(CB_GETCOUNT,0,0),True

Button.ClassName = "Button"
Button.Text      = "&Button"
Button.Style     = WS_CHILD OR BS_DEFPUSHBUTTON
Button.Left      = 125
Button.Width     = 75
Button.Height    = 25
Button.Parent    = Main
Button.SetEvent(BN_CLICKED,@Click)
Button.Visible   = 1

Radio.ClassName = "Button"
Radio.Text      = "&Button"
Radio.Style     = WS_CHILD OR BS_AUTORADIOBUTTON
Radio.Left      = 210
Radio.Width     = 60
Radio.Height    = 17
Radio.Parent    = Main
Radio.SetEvent(BN_CLICKED,@Click)
Radio.Visible   = 1
Radio.Group = 1

Radio1.ClassName = "Button"
Radio1.Text      = "&Button"
Radio1.Style     = WS_CHILD OR BS_AUTORADIOBUTTON
Radio1.Left      = 280
Radio1.Width     = 60
Radio1.Height    = 17
Radio1.Parent    = Main
Radio1.SetEvent(BN_CLICKED,@Click)
Radio1.Visible   = 1

Radio2.ClassName = "Button"
Radio2.Text      = "&Button"
Radio2.Style     = WS_CHILD OR BS_AUTORADIOBUTTON
Radio2.Top       = 20
Radio2.Left      = 210
Radio2.Width     = 60
Radio2.Height    = 17
Radio2.Parent    = Main
Radio2.SetEvent(BN_CLICKED,@Click)
Radio2.Visible   = 1
Radio2.Group = 1

Radio3.ClassName = "Button"
Radio3.Text      = "&Button"
Radio3.Style     = WS_CHILD OR BS_AUTORADIOBUTTON
Radio3.Top       = 20
Radio3.Left      = 280
Radio3.Width     = 60
Radio3.Height    = 17
Radio3.Parent    = Main
Radio3.SetEvent(BN_CLICKED,@Click)
Radio3.Visible   = 1

ToolBar.ClassName = TOOLBARCLASSNAME
ToolBar.Style     = ToolBarStyle
ToolBar.Top       = 28
ToolBar.Width     = 160
ToolBar.Height    = 26
ToolBar.Parent    = Main
ToolBar.Visible   = 1

Dim As TPopupMenu DropMenu
Dim As TMenuItem MI
MI.Caption = "Item 1"
MI.CommandID = 200
MI.OnClick = @ItemClick
DropMenu.AddSubItem Mi

Dim As TToolButtons ToolButtons
ToolButtons.Parent = ToolBar
ToolButtons.AddButton tsSeparator
ToolButtons.AddButton tsButton
ToolButtons.AddButton tsSeparator
ToolButtons.AddButton tsCheckGroup
ToolButtons.AddButton tsCheckGroup
ToolButtons.AddButton tsSeparator
ToolButtons.AddButton tsCheck
ToolButtons.AddButton tsSeparator
ToolButtons.AddButton tsDropDown,@DropMenu

TabControl.ClassName = "SysTabControl32"
TabControl.Style     = WS_CHILD
TabControl.Top       = 28
TabControl.Width     = 260
TabControl.Height    = 126
TabControl.Parent    = DesignForm
TabControl.Visible   = 1
TabControl.SetEvent(TCN_SELCHANGE,@Change)

Dim As TTabItem Ti
Dim As TTabItems TabItems
TabItems.Parent = TabControl
Ti.Caption = "Tab 1"
TabItems.AddTab Ti
Ti.Caption = "Tab 2"
TabItems.AddTab Ti
TabItems.TabIndex = 1

Application.Run

Sub Click(Sender As TControl)
    MessageBox Sender,"Click",Sender.ClassName,0
    If Sender = "TFreeBasicMain" then MessageBox Sender,"ClassName = " & Sender,Sender.ClassName,0
End Sub

Sub wPaint(Sender As TControl,DC As HDC,R As RECT)
    Dim As Integer x,y
    For y = 0 To R.Bottom Step 4
        For x = 0 To R.Right Step 4
            SetPixel(Dc,x,y,0)
        Next x
    Next y
End Sub

Sub ItemClick(Sender As TMenuItem)
    MessageBox Main,"Menu Item Click","",0
End Sub

Sub Change(Sender As TControl)
    MessageBox Main,"change","",0
End Sub



