'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

Type TMenuItem
    private:
    fCaption As String
    fChecked As Boolean
    fRadioItem As Boolean
    public:
    Handle    As HMENU
    Parent    As HMENU
    Items     As TMenuItem Ptr
    ItemCount As Integer
    CommandID As Integer
    Declare Property Caption As String
    Declare Property Caption(value As String)
    Declare Property Checked As Boolean
    Declare Property Checked(value As Boolean)
    Declare Property RadioItem As Boolean
    Declare Property RadioItem(value As Boolean)
    Declare Sub AddItem(BYREF Item As TMenuItem)
    Declare Sub AddSubItem(BYREF Item As TMenuItem)
    Declare Sub DeleteItem(Index As Integer)
    Declare Sub InsertItem(Index As Integer,Item As TMenuItem)
    Declare Constructor
    Declare Destructor
    Declare Operator Cast As String
    Declare Operator Cast As Integer
    OnClick As Any Ptr
End Type

'''TMenu
Type TMenu
    private:
    fParent As HWND
    public:
    Handle As HMENU
    ItemCount As Integer
    Items As TMenuItem Ptr
    Declare Property Parent As HWND
    Declare Property Parent(value As HWND)
    Declare Sub AddItem(BYREF Item As TMenuItem)
    Declare Sub DeleteItem(Index As Integer)
    Declare Sub InsertItem(Index As Integer,Item As TMenuItem)
    Declare Sub Create
    Declare Operator Cast As String
    Declare Operator Cast As HMENU
    Declare Constructor
    Declare Destructor
End Type

'''TPopupMenu
Type TPopupMenu
    private:
    FWindow As HWND
    public:
    Handle As HMENU
    ItemCount As Integer
    Items As TMenuItem Ptr
    Declare Property Window As HWND
    Declare Property Window(value As HWND)
    Declare Sub AddItem(BYREF Item As TMenuItem)
    Declare Sub AddSubItem(BYREF Item As TMenuItem)
    Declare Sub DeleteItem(Index As Integer)
    Declare Sub InsertItem(Index As Integer,BYREF Item As TMenuItem)
    Declare Operator Cast As String
    Declare Operator Cast As HMENU
    Declare Constructor
    Declare Destructor
End Type

'''TMenuItem
Operator TMenuItem.Cast As String
    Return "TMenuItem"
End Operator

Operator TMenuItem.Cast As Integer
   If Handle Then
       Return Cast(Integer,Handle)
   Else
       Return CommandId
   End If
End Operator
Property TMenuItem.Caption As String
    Return fCaption 
End Property

Property TMenuItem.Caption(value As String)
    fCaption = Value
End Property

Property TMenuItem.Checked As Boolean
    Return fChecked
End Property

Function GetChecked(Check As Integer) As Long
    Dim As Long ICheck(2) = {MF_UNCHECKED,MF_CHECKED}
    Return ICheck(Check)
End Function

Property TMenuItem.Checked(value As Boolean)
    fChecked = value
    CheckMenuItem(Parent,CommandID,MF_BYCOMMAND OR GetChecked(fChecked))
End Property

Property TMenuItem.RadioItem As Boolean
    Return fRadioItem
End Property

Property TMenuItem.RadioItem(value As Boolean)
End Property

Sub TMenuItem.AddItem(BYREF Item As TMenuItem)
    ItemCount += 1
    Items = ReAllocate(Items,SizeOf(TMenuItem)*ItemCount)
    Items[ItemCount -1] = Item
    With Items[ItemCount -1]
        .Handle = CreatePopupMenu
        .Parent = Handle
        AppendMenu(Handle, MF_STRING or MF_POPUP OR GetChecked(.Checked), CInt(.Handle), .Caption)
    End With
End Sub

Sub TMenuItem.AddSubItem(BYREF Item As TMenuItem)
    ItemCount += 1
    Items = ReAllocate(Items,SizeOf(TMenuItem)*ItemCount)
    Items[ItemCount -1] = Item
    With Items[ItemCount -1]
        .Parent = Handle
        If .Caption = "-" Then
            .CommandID = -1
            AppendMenu(Handle, MF_STRING OR MF_SEPARATOR, .CommandID,"")
        Else
            AppendMenu(Handle, MF_STRING OR GetChecked(.Checked), .CommandID, .Caption)
        End If
    End With
End Sub

Sub TMenuItem.DeleteItem(Index As Integer)
End Sub

Sub TMenuItem.InsertItem(Index As Integer,Item As TMenuItem)
End Sub

Constructor TMenuItem
    fCaption = ""
End Constructor

Destructor TMenuItem
    If Handle Then DestroyMenu(Handle)
    Items = cAllocate(0)
End Destructor

'''TMenu
Operator TMenu.Cast As String
    Return "TMenu"
End Operator

Operator TMenu.Cast As HMENU
    Return Handle
End Operator

Property TMenu.Parent As HWND
    Return fParent
End Property

Property TMenu.Parent(value As HWND)
    FParent = value
    If FParent Then
       If Handle Then
          SetMenu FParent,Handle 
          DrawMenuBar FParent
       Else
          Create
       End If
    End If    
End Property

Sub TMenu.AddItem(BYREF Item As TMenuItem)
    ItemCount += 1
    Items = ReAllocate(Items,SizeOf(TMenuItem)*ItemCount)
    Items[ItemCount -1] = Item
    With Items[ItemCount -1]
        .Handle = CreatePopupMenu
        AppendMenu(Handle, MF_STRING or MF_POPUP OR GetChecked(.Checked), CInt(.Handle), .Caption)
        DrawMenuBar FParent
    End With
End Sub

Sub TMenu.DeleteItem(Index As Integer)
End Sub

Sub TMenu.InsertItem(Index As Integer,Item As TMenuItem)
End Sub

Sub TMenu.Create
    Handle = CreateMenu
    If Handle Then
        SetMenu FParent,Handle
        DrawMenuBar FParent
    End If
End Sub

Constructor TMenu
    Items = cAllocate(0)
End Constructor

Destructor TMenu
    If Handle Then
        Items = cAllocate(0)
        DestroyMenu(Handle)
    End If
End Destructor

'''TPopupMenu
Operator TPopupMenu.Cast As String
    Return "TPopupMenu"
End Operator

Operator TPopupMenu.Cast As HMENU
    Return Handle
End Operator

Property TPopupMenu.Window As HWND
    Return FWindow
End Property

Property TPopupMenu.Window(value As HWND)
    FWindow = value
    If Handle = 0 Then Handle = CreatePopupMenu
End Property

Sub TPopupMenu.AddItem(BYREF Item As TMenuItem)
    ItemCount += 1
    Items = ReAllocate(Items,SizeOf(TMenuItem)*ItemCount)
    Items[ItemCount -1] = Item
    With Items[ItemCount -1]
        .Handle = CreatePopupMenu
        AppendMenu(Handle, MF_STRING or MF_POPUP OR GetChecked(.Checked), CInt(.Handle), .Caption)
    End With
End Sub

Sub TPopupMenu.AddSubItem(BYREF Item As TMenuItem)
    ItemCount += 1
    Items = ReAllocate(Items,SizeOf(TMenuItem)*ItemCount)
    Items[ItemCount -1] = Item
    With Items[ItemCount -1]
        .Handle = 0
        AppendMenu(Handle, MF_STRING OR GetChecked(.Checked), .CommandId, .Caption)
    End With
End Sub

Sub TPopupMenu.DeleteItem(Index As Integer)
End Sub

Sub TPopupMenu.InsertItem(Index As Integer,BYREF Item As TMenuItem)
End Sub

Constructor TPopupMenu
    Handle = CreatePopupMenu
    ItemCount = 0
    Items = cAllocate(0)
End Constructor

Destructor TPopupMenu
    DeAllocate Items
End Destructor