'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

Type TApplication
    private:
    FTitle     As String
    FRichLib   As HMODULE
    FMessage   As MSG
    Dim DoMessage As Sub(BYREF Sender As TApplication,BYREF Message As TMessage,BYREF Control As TControl)
    public:
    Message    As TMessage
    Instance   As HINSTANCE
    Accel      As HACCEL
    ClassCount As Integer
    Classes    As TClass Ptr
    Declare Property Title As String
    Declare Property Title(Value As String)
    Declare Sub AddClass(FClass As String,FExStyle As Long,FStyle As Long,FWidth As Integer,FHeight As Integer,FAlias As String = "")
    Declare Function GetClass(FClass As String,BYREF ClassStruct As TClass) As Boolean
    Declare Function GetStyle(FClass As String) As Long
    Declare Function GetAlias(FClass As String) As String
    Declare Function GetExStyle(FClass As String) As Long    
    Declare Function GetBounds(FClass As String) As POINT
    Declare Sub Run
    Declare Constructor
    Declare Destructor
    OnMessage As Any Ptr
End Type

Sub TApplication.AddClass(FClass As String,FExStyle As Long,FStyle As Long,FWidth As Integer,FHeight As Integer,FAlias As String = "")
    ClassCount += 1
    Classes = ReAllocate(Classes,ClassCount*SizeOF(TClass))
    Classes[ClassCount-1].ClassName  = FClass
    Classes[ClassCount-1].ExStyle    = FExStyle
    Classes[ClassCount-1].Style      = FStyle
    Classes[ClassCount-1].Width      = FWidth
    Classes[ClassCount-1].Height     = FHeight
    Classes[ClassCount-1].ClassAlias = FAlias
End Sub

Function TApplication.GetClass(FClass As String,BYREF ClassStruct As TClass) As Boolean
        Dim As Integer i
        FillMemory @FClass,0,SizeOF(TClass)
        For i = 0 To ClassCount-1
            If UCase(FClass) = UCase(Classes[i].ClassName) Then
                ClassStruct = Classes[i]
                Return True
            End If
        Next i
        Return False
End Function

Function TApplication.GetStyle(FClass As String) As Long
        Dim As Integer i
        For i = 0 To ClassCount-1
            If UCase(FClass) = UCase(Classes[i].ClassName) Then Return Classes[i].Style
        Next i
End Function
    
Function TApplication.GetExStyle(FClass As String) As Long
        Dim As Integer i
        For i = 0 To ClassCount-1
            If UCase(FClass) = UCase(Classes[i].ClassName) Then Return Classes[i].ExStyle
        Next i
End Function
    
Function TApplication.GetAlias(FClass As String) As String
        Dim As Integer i
        For i = 0 To ClassCount-1
            If UCase(FClass) = UCase(Classes[i].ClassName) Then Return Classes[i].ClassAlias
        Next i
End Function
    
Function TApplication.GetBounds(FClass As String) As POINT
        Dim As Integer i
        Dim As POINT P
        For i = 0 To ClassCount-1
            If UCase(FClass) = UCase(Classes[i].ClassName) Then 
                P.x = Classes[i].Width
                P.y = Classes[i].Height
                Return P
            End If
        Next i
End Function

Property TApplication.Title As String
    Return FTitle
End Property

Property TApplication.Title(Value As String)
    FTitle = Value
    'to do
End Property

Sub TApplication.Run
    Dim As TMessage Message
    Dim As TControl Ptr Control
    While GetMessage(@FMessage, NULL, 0, 0)
          If TranslateAccelerator(FMessage.hWnd, Accel, @FMessage) = 0 Then
             TranslateMessage(@FMessage)
             DispatchMessage(@FMessage)
             Message.hWnd     = FMessage.hWnd
             Message.Msg      = FMessage.Message
             Message.wParam   = FMessage.wParam
             Message.lParam   = FMessage.lParam
             Message.wParamLo = LoWord(FMessage.wParam)
             Message.wParamHi = HiWord(FMessage.wParam)
             Message.lParamLo = LoWord(FMessage.lParam)
             Message.lParamHi = HiWord(FMessage.lParam)
             Control = Cast(TControl Ptr,GetWindowLong(FMessage.hWnd,GWL_USERDATA))
             If OnMessage Then
                 DoMessage = OnMessage
                 DoMessage(This,Message,*Control) ' you can intercept the desired message here
             End If
          End If
    Wend
End Sub

Constructor TApplication 
    AddClass("Static",WS_EX_TRANSPARENT,SS_SIMPLE,97,17,"Static Text")
    AddClass("Static",WS_EX_TRANSPARENT,SS_BITMAP,97,17,"Bitmap Image")
    AddClass("Static",WS_EX_TRANSPARENT,SS_ICON,97,17,"Icon Image")
    AddClass("Button",0,BS_PUSHBUTTON,75,25,"Button")
    AddClass("Button",0,BS_AUTOCHECKBOX,75,25,"CheckBox")
    AddClass("Button",0,BS_AUTORADIOBUTTON,75,25,"RadioButton")
    AddClass("Button",WS_EX_TRANSPARENT,BS_GROUPBOX,75,25,"GroupBox")
    AddClass("Edit",WS_EX_CLIENTEDGE,ES_NOHIDESEL OR ES_AUTOHSCROLL,121,21,"Edit Box")
    AddClass("ComboBox",0,CBS_HASSTRINGS OR CBS_DROPDOWNLIST,121,42,"ComboBox")
    AddClass("ListBox",WS_EX_CLIENTEDGE,LBS_HASSTRINGS OR LBS_NOINTEGRALHEIGHT,121,121,"ListBox")
    AddClass("ScrollBar",0,SBS_HORZ,121,19,"Horizontal ScrollBar")
    AddClass("ScrollBar",0,SBS_VERT,19,121,"Vertical ScrollBar")
    InitCommonControls
    Instance = GetModuleHandle(NULL)
    FRichLib = LoadLibrary("RichEd20")
End Constructor

Destructor TApplication
    FreeLibrary FRichLib
End Destructor
