'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

Type TControl
    private:
    FText            As String
    FLeft            As Integer
    FTop             As Integer
    FWidth           As Integer 
    FHeight          As Integer
    FClientHeight    As Integer
    FClientWidth     As Integer
    FParent          As HWND
    FCursor          As HCURSOR
    FEnabled         As Boolean
    FVisible         As Boolean
    FGroup           As Boolean
    public:
    Handle           As HWND
    ClassName        As String
    ExStyle          As Long
    Style            As Long
    ConstraintLeft   As Integer
    ConstraintTop    As Integer
    ConstraintHeight As Integer
    ConstraintWidth  As Integer
    Font             As TFont
    MainMenu         As TMenu
    PopupMenu        As TPopupMenu
    SubTypeCount     As Integer
    SubType          As Any Ptr Ptr
    Tag              As Any Ptr
    Declare Property Text As String
    Declare Property Text(Value As String)
    Declare Property Left As Integer
    Declare Property Left(Value As Integer)
    Declare Property Top As Integer
    Declare Property Top(Value As Integer)
    Declare Property Width As Integer
    Declare Property Width(Value As Integer)
    Declare Property Height As Integer
    Declare Property Height(Value As Integer)
    Declare Property ClientHeight As Integer
    Declare Property ClientWidth As Integer
    Declare Property Parent As HWND
    Declare Property Parent(Value As HWND)
    Declare Property Cursor As HCURSOR
    Declare Property Cursor(Value As HCURSOR)
    Declare Property Enabled(Value As Boolean)
    Declare Property Enabled As Boolean
    Declare Property Visible(Value As Boolean)
    Declare Property Visible As Boolean
    Declare Property Group(Value As Boolean)
    Declare Property Group As Boolean
    Declare Function Perform(Msg As UINT,wParam As WPARAM,lParam As LPARAM) As LRESULT
    Declare Sub Register(FClassName As String ,FWndProc As WNDPROC)
    Declare Sub SetEvent(Message As Long,Event As Any Ptr)
    Declare Sub Focus
    Declare Sub BringToFront
    Declare Sub Update
    Declare Sub Repaint
    Declare Sub Invalidate
    Declare Sub Create
    Declare Operator Cast As String
    Declare Operator Cast As HWND
    Declare Constructor
    Declare Destructor
    EventCount As Integer
    Events     As TEvent Ptr
End Type

Operator TControl.Cast As String
    Return ClassName 
End Operator

Operator TControl.Cast As HWND
    Return Handle 
End Operator

Property TControl.Text As String
   Return FText
End Property

Property TControl.Text(Value As String)
   FText = Value
   If Handle Then SetWindowText Handle,FText
End Property

Property TControl.Left As Integer
   Return FLeft
End Property

Property TControl.Left(Value As Integer)
   FLeft = Value
   If Handle Then MoveWindow Handle,FLeft, FTop, FWidth, FHeight, True
End Property

Property TControl.Top As Integer
   Return FTop
End Property

Property TControl.Top(Value As Integer)
   FTop = Value
   If Handle Then MoveWindow Handle,FLeft, FTop, FWidth, FHeight, True
End Property

Property TControl.Width As Integer
   Return FWidth
End Property

Property TControl.Width(Value As Integer)
   FWidth = Value
   If Handle Then MoveWindow Handle,FLeft, FTop, FWidth, FHeight, True
End Property

Property TControl.Height As Integer
   Return FHeight
End Property

Property TControl.Height(Value As Integer)
   FHeight = Value
   If Handle Then MoveWindow Handle,FLeft, FTop, FWidth, FHeight, True
End Property

Property TControl.ClientHeight As Integer
   Dim As RECT R
   GetClientRect Handle,@R
   FClientHeight = R.Bottom
   Return FClientHeight
End Property

Property TControl.ClientWidth As Integer
   Dim As RECT R
   GetClientRect Handle,@R
   ClientWidth = R.Right
   Return FClientWidth
End Property

Property TControl.Parent As HWND
   Return FParent
End Property

Property TControl.Parent(Value As HWND)
   FParent = Value
   If Handle Then 
       SetParent Handle,FParent
   Else
       Create
   End If
End Property

Property TControl.Cursor As HCURSOR
   Return FCursor
End Property

Property TControl.Cursor(Value As HCURSOR)
   FCursor = Value
End Property

Property TControl.Enabled As Boolean
    Return FEnabled
End Property

Property TControl.Enabled(Value As Boolean)
    FEnabled = Value 
    If Handle Then EnableWindow Handle,FEnabled
End Property

Property TControl.Visible As Boolean
    Return FVisible
End Property

Property TControl.Visible(Value As Boolean)
    FVisible = Value
    If Handle Then ShowWindow Handle, FVisible
End Property

Property TControl.Group As Boolean
    Return FGroup
End Property

Property TControl.Group(Value As Boolean)
    FGroup = Value
    If Handle Then SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle,GWL_STYLE) OR WS_GROUP)
End Property

Sub TControl.Focus
    If Handle Then SetFocus Handle
End Sub

Sub TControl.BringToFront
    If Handle Then BringWindowToTop Handle
End Sub

Sub TControl.Update
    If Handle Then UpdateWindow Handle
End Sub

Sub TControl.Repaint
    If Handle Then 
       RedrawWindow Handle,0,0,RDW_ERASE OR RDW_INVALIDATE
       UpdateWindow Handle
    End If
End Sub

Sub TControl.Invalidate
    If Handle Then InvalidateRect Handle,0,True
End Sub

Function TControl.Perform(Msg As UINT,wParam As WPARAM,lParam As LPARAM) As LRESULT
    Return SendMessage(Handle,Msg,wParam,lParam)
End Function

Sub TControl.SetEvent(Message As Long,Event As Any Ptr)
    EventCount += 1
    Events = ReAllocate(Events,SizeOF(TEvent)*EventCount)
    Events[EventCount -1].Message = Message
    Events[EventCount -1].Event   = Event
End Sub

Sub TControl.Register(FClassName As String ,FWndProc As WNDPROC)
    Dim As WNDCLASS Wc
    ClassName        = FClassName
    Wc.lpszClassName = StrPtr(ClassName)
    Wc.lpfnWndProc   = FWndProc
    Wc.hInstance     = GetModuleHandle(NULL)
    Wc.hbrBackground = Cast(HBRUSH,16)
    Wc.hCursor       = LoadCursor(NULL,IDC_ARROW)
    RegisterClass(@Wc)
End Sub

Sub TControl.Create
    Dim As Integer Grouped(2) = {0,WS_GROUP}
    Handle = CreateWindowEx(ExStyle,_
                            ClassName,_
                            FText,_
                            Style OR Grouped(FGroup),_
                            FLeft,_
                            FTop,_
                            FWidth,_
                            FHeight,_
                            FParent,_
                            NULL,_
                            GetModuleHandle(NULL),_
                            NULL)
    If Handle Then
        SetWindowLong(Handle,GWL_USERDATA,CInt(@This))
        Font.Parent = Handle
        MainMenu.Parent = Handle
        Enabled = 1
    End If
End Sub

Constructor TControl
    Style = WS_CLIPSIBLINGS OR WS_CLIPCHILDREN
End Constructor

Destructor TControl
    DeAllocate SubType
End Destructor

   