'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

#DEFINE TBSTYLE_TRANSPARENT &H8000
#DEFINE TBN_DROPDOWN (TBN_FIRST - 10)

Enum TToolButtonStyle
    tsButton
    tsCheck
    tsCheckGroup
    tsDropDown
    tsSeparator
End Enum

Dim Shared  As Long ToolButtonStyles(tsButton To tsSeparator) = {TBSTYLE_BUTTON,TBSTYLE_CHECK,TBSTYLE_CHECKGROUP,TBSTYLE_DROPDOWN,TBSTYLE_SEP}
Type TButtonData
       CommandID As Integer
       Hint      As String
       DropDown  As TPopupMenu Ptr
       OnClick   As Any Ptr
End Type
Type TToolButtons
    private:
    FButtonWidth   As Integer
    FButtonHeight  As Integer
    FParent        As HWND
    public:
    Handle         As HWND
    ButtonCount    As Integer
    Buttons        As TBBUTTON Ptr
    ShowCaptions   As Boolean
    Images         As HIMAGELIST
    HotImages      As HIMAGELIST
    DisabledImages As HIMAGELIST
    Declare Property ButtonWidth As Integer
    Declare Property ButtonWidth(Value As Integer)
    Declare Property ButtonHeight As Integer
    Declare Property ButtonHeight(Value As Integer)
    Declare Property Parent As HWND
    Declare Property Parent(Value As HWND)
    Declare Operator Cast As String
    Declare Sub AddButton(ButtonStyle As TToolButtonStyle = tsButton,DropMenu As TPopupMenu Ptr = NULL,CommandID As Integer = -1,Caption As String = "",Hint As String = "",ImageIndex As Integer = -1,Click As Any Ptr = NULL)
    Declare Sub DeleteButton(Index As Integer)
    Declare Constructor
    Declare Destructor
End Type

'Namespace TToolButtonsProc
' Here is subclassing procedure sample for local processing messages
'     Dim Shared As WNDPROC OldProc 
'     Function WndProc(hWnd As HWND,Msg As UINT,wParam As WPARAM,lParam As LPARAM) As LRESULT
'         Dim As TToolButtons Ptr ToolBar
'         ToolBar = Cast(TToolButtons Ptr,GetWindowLong(hWnd,GWL_USERDATA))
'         If ToolBar Then 
'             ToolBar->WindowProc(hWnd,Msg,wParam,lParam)
'             If Msg = CM_COMMAND Then
'                Static As Integer Index,CommandId
'                Dim As TBBUTTON Tb
'                Dim As Sub(BYREF Sender As TBBUTTON) DoClick
'                CommandID = wParam
'                If CommandID <> 0 Then
'                    Index = SendMessage(hWnd,TB_COMMANDTOINDEX,wParam,0)
'                    SendMessage(hWnd,TB_GETBUTTON,Index,CInt(@Tb))
'                    If Cast(TButtonData Ptr,Tb.dwData)->OnClick <> NULL Then
'                       DoClick = Cast(TButtonData Ptr,Tb.dwData)->OnClick
'                       DoClick(Tb)
'                    End If
'                End If
'             End If
'             If Msg = CN_NOTIFY Then 
'                 Dim As TBNOTIFY PTR Tbn
'                 Dim As TBBUTTON Tb
'                 Dim As RECT R
'                 Tbn = Cast(TBNOTIFY PTR,lParam) 
'                 Select Case Tbn->hdr.Code
'                     Case TBN_DROPDOWN
'                          If Tbn->iItem <> -1 Then
'                             SendMessage(Tbn->hdr.hwndFrom, TB_GETRECT, Tbn->iItem, CInt(@R))
'                             MapWindowPoints(Tbn->hdr.hwndFrom, 0, @R, 2)
'                             SendMessage(Tbn->hdr.hwndFrom,TB_GETBUTTON,SendMessage(Tbn->hdr.hwndFrom,TB_COMMANDTOINDEX,Tbn->iItem,0),CInt(@Tb))
'                             TrackPopupMenu (Cast(TButtonData Ptr,Tb.dwData)->DropDown, 0, R.Left, R.Bottom, 0, Tbn->hdr.hwndFrom, NULL)
'                          End If
'                 End Select
'             End If
'             
'         End If
'         Return CallWindowProc(OldProc,hWnd,Msg,wParam,lParam)
'     End Function
'End Namespace
 
Property TToolButtons.Parent As HWND
    Return FParent
End Property
    
Property TToolButtons.Parent(Value As HWND)
    FParent = value
    If FParent Then
         SendMessage(FParent,TB_BUTTONSTRUCTSIZE,SizeOf(TBBUTTON),0)
         SendMessage(FParent,TB_SETEXTENDEDSTYLE, 0, SendMessage(FParent,TB_GETEXTENDEDSTYLE, 0, 0) OR TBSTYLE_EX_DRAWDDARROWS)
         If Images Then SendMessage(FParent,TB_SETIMAGELIST,0,CInt(Images))
         If HotImages Then SendMessage(FParent,TB_SETHOTIMAGELIST,0,CInt(HotImages))
         If DisabledImages Then SendMessage(FParent,TB_SETDISABLEDIMAGELIST,0,CInt(DisabledImages))
         With *Cast(TControl Ptr,GetWindowLong(FParent,GWL_USERDATA))
           .SubTypeCount += 1
           .SubType = ReAllocate(.SubType,SizeOF(Any Ptr)*.SubTypeCount)
           .SubType[.SubTypeCount-1] = @This
         End With    
    End If
End Property
    
Property TToolButtons.ButtonWidth As Integer
    Return FButtonWidth
End Property

Property TToolButtons.ButtonWidth(Value As Integer)
    FButtonWidth = Value
    If Handle Then SendMessage(FParent,TB_SETBUTTONSIZE,0,MakeLong(FButtonWidth,FButtonHeight))
End Property

Property TToolButtons.ButtonHeight As Integer
    Return FButtonHeight
End Property

Property TToolButtons.ButtonHeight(Value As Integer)
    FButtonHeight = Value
    If Handle Then SendMessage(FParent,TB_SETBUTTONSIZE,0,MakeLong(FButtonWidth,FButtonHeight))
End Property
    
Sub TToolButtons.AddButton(ButtonStyle As TToolButtonStyle = tsButton,DropMenu As TPopupMenu Ptr = NULL,CommandID As Integer = -1,Caption As String = "",Hint As String = "",ImageIndex As Integer = -1,Click As Any Ptr = NULL)
    Dim As TButtonData Ptr BD
    ButtonCount += 1
    Buttons = ReAllocate(Buttons,SizeOF(TBBUTTON)*ButtonCount)
    With Buttons[ButtonCount -1]
        BD = Allocate(SizeOf(TButtonData))
        BD->Hint = Hint
        BD->DropDown = DropMenu
        BD->OnClick = Click
        .fsStyle = ToolButtonStyles(ButtonStyle)
        If ShowCaptions Then .iString = CInt(StrPtr(Caption)) Else .iString = 0 
        .dwData  = Cast(DWORD,BD)
        .iBitmap = ImageIndex
        If .fsStyle  <> tsSeparator Then 
           If CommandID = -1 Then
               .idCommand = 100 + ButtonCount 
           Else
               .idCommand = CommandID
           End If
        Else 
           .idCommand = -1
           .iBitmap = -1
        End If
        .fsState = TBSTATE_ENABLED
    End With
    SendMessage(FParent,TB_ADDBUTTONS,1,CInt(@Buttons[ButtonCount -1]))
End Sub

Sub TToolButtons.DeleteButton(Index As Integer)
    ''' to do
End Sub
 
Operator TToolButtons.Cast As String
   Return "TToolButtons"
End Operator
    
Constructor TToolButtons
     FButtonWidth  = 23
     FButtonHeight = 22
     Buttons = cAllocate(0)
     ButtonCount = 0
End Constructor

Destructor TToolButtons
    Buttons = cAllocate(0)
    ButtonCount = 0
End Destructor

    
